package xxx;
import base.*;
import java.sql.*;
import java.text.*;


/**
 * ƎʃANZXڕ\쐬
 */
public class CategoryAccessBean implements I_Access_Page {
	private String dbdata = "DB value";
	private boolean forwardPage;
	private boolean backPage;
	private boolean forwardPage2;
	private boolean backPage2;

	public String getDbdata() {
		return dbdata;
	}

	public String getDisableForwardPage() {
		return forwardPage ? "" : " disabled";
	}

	public String getDisableBackPage() {
		return backPage ? "" : " disabled";
	}

	public String getDisableForwardPage2() {
		return forwardPage2 ? "" : " disabled";
	}

	public String getDisableBackPage2() {
		return backPage2 ? "" : " disabled";
	}

	/**
	 * ƎʃANZXڕ\̒g쐬
	 */
	public void searchDB(DataBase db, SelectCondBean selectcondBean) {
		try {
			Statement st = db.createStatement();
			ResultSet rs;
			NumberFormat numFormat = NumberFormat.getNumberInstance();
			int i;

			// JeS擾
			String category = selectcondBean.getCategory();

			// 及L̃R[i[R[h擾
			String cornerCode = selectcondBean.getGroupCorner(db);

			// iƎj̏i[邽߂̔zm
			int num;
			if (category.equals("/"))
				num = CommonSql.getCategoryCount(st, category);
			else
				num = selectcondBean.getPageSize2();
			String categoryCodes[] = new String[num];   // ƎiƁjR[h
			String categoryNames[] = new String[num];   // ƎiƁj

			// e[uʂ̃wb_@ETEʕω
			String table = selectcondBean.getTable();
			String prefix = "", dateUnit = "";
			if (table.equals("MONTH")) {
				prefix = "SMCC";
				dateUnit = "";
			} else if (table.equals("WEEK")) {
				prefix = "SWCC";
				dateUnit = "T";
			} else if (table.equals("DATE")) {
				prefix = "SDCC";
				dateUnit = "t";
			}

			// where
			StringBuffer where = new StringBuffer();
			where.append("where [PF]_ACCESS[TB]_DATE between '" + selectcondBean.getDateFrom() + "' and '" + selectcondBean.getDateTo() + "'\n");
			where.append("and [PF]_CORNER_CODE='" + cornerCode + "'\n");
			if (!category.equals("/"))
				where.append("and [PF]_BUSINESSCATEGORY_CODE='" + category + "' \n");
			CommonSql.setAttributeSql(where, selectcondBean);

			// ƎiƁj̏zɎ擾
			if (category.equals("/"))
				rs = CommonSql.getCategoryResult(st, category);
			else {
				// Ƃ̏ꍇAANZX̑ɕ\
				StringBuffer s01 = new StringBuffer();
				s01.append("select [PF]_COMPANY_CODE,sum([PF]_ACCESSCOUNT_NUM) as S_ACCESSCOUNT_NUM \n");
				s01.append("from S_[TB]_CORNER_COMPANY \n");
				s01.append(where);
				s01.append("group by [PF]_COMPANY_CODE");

				StringBuffer sql = new StringBuffer();
				sql.append("select MCM_COMPANY_CODE as CODE,MCM_DISPNAME_TXT as NAME,S_ACCESSCOUNT_NUM \n");
				sql.append("from M_COMPANY,(").append(s01).append(") s01 \n");
				sql.append("where MCM_BUSINESSCATEGORY_CODE='").append(category).append("'\n");
				sql.append("and MCM_COMPANY_CODE=[PF]_COMPANY_CODE(+) \n");
        sql.append(CommonSql.setAttributeSql2(selectcondBean));
				sql.append("ORDER BY NVL(S_ACCESSCOUNT_NUM,0) DESC,MCM_SORT_NUM");

				CommonFunc.substitute(sql, "[PF]", prefix);
				CommonFunc.substitute(sql, "[TB]", table);

				int pageSize2 = selectcondBean.getPageSize2();
				rs = st.executeQuery(CommonSql.RowRange(sql.toString(), selectcondBean.getPageNo2() * pageSize2, pageSize2 + 1));
			}
			forwardPage2 = false;
			backPage2 = (selectcondBean.getPageNo2() != 0);
			for (i = 0; rs.next(); i++) {
				if (i == num) {
					forwardPage2 = true;
					break;
				}

				categoryCodes[i] = rs.getString("CODE");
				categoryNames[i] = rs.getString("NAME");
			}
			num = i;

			int categoryTotals[] = new int[num];        // ƎiƁj̃ANZXv
			int counterTbl[] = new int[num];            // ANZXJE^
			String dates[] = new String[num];           // 

			// ƎiƁjR[h̃J擾
			String s_code;
			if (category.equals("/"))
				s_code = "[PF]_BUSINESSCATEGORY_CODE";
			else
				s_code = "[PF]_COMPANY_CODE";

			// tAJeSʂ̃ANZXWvpTuNG
			StringBuffer q01 = new StringBuffer();
			q01.append("select ");
			q01.append("[PF]_ACCESS[TB]_DATE as S_DATE,");
			q01.append(s_code + " as S_CATEGORY_CODE,");
			q01.append("sum([PF]_ACCESSCOUNT_NUM) as S_ACCESSCOUNT_NUM \n");
			q01.append("from S_[TB]_CORNER_COMPANY \n");
			q01.append(where);
			q01.append("group by [PF]_ACCESS[TB]_DATE," + s_code + " \n");

			// J̐ړƃe[uʖu
			CommonFunc.substitute(q01, "[PF]", prefix);
			CommonFunc.substitute(q01, "[TB]", table);

			// ʂɏWv邽߂select
			StringBuffer select = new StringBuffer();
			select.append("sum(S_ACCESSCOUNT_NUM) as ALLCOUNT \n");
			for (i = 0; i < num; i++)
				select.append(",sum(case S_CATEGORY_CODE when '" + categoryCodes[i] + "' then S_ACCESSCOUNT_NUM else 0 end) as COUNT" + i + "\n");

			// v擾邽߂SQL
			StringBuffer sql_ttl = new StringBuffer();
			sql_ttl.append("select " + select);
			sql_ttl.append("from (" + q01 + ") \n");

			// sƂ̃ANZX擾邽߂̃TuNG
			StringBuffer q02 = new StringBuffer();
			q02.append("select " + select + ",S_DATE \n");
			q02.append("from (" + q01 + ") \n");
			q02.append("group by S_DATE");

			// x}X^ƌ
			StringBuffer q03 = new StringBuffer();
			q03.append("select q02.*,MHD_HOLIDAY_CLS \n");
			q03.append("from (" + q02 + ") q02 \n");
			q03.append(",M_HOLIDAY \n");
			q03.append("where S_DATE=MHD_HOLIDAY_DATE(+) \n");
			q03.append("order by S_DATE \n");

			// KvȔ͈͂̃f[^݂̂𒊏o
			StringBuffer sql_row = new StringBuffer();
			int pageSize = selectcondBean.getPageSize();
			int offset = selectcondBean.getPageNo() * pageSize;
			sql_row.append(CommonSql.RowRange(q03.toString(), offset, pageSize + 1)); // y[W邩`FbN邽߂Pǂ

			// htmle[ũwb_쐬
			StringBuffer tags = new StringBuffer();
			tags.append("<tr class='header'>\n");
			tags.append("<td class='header_txt' nowrap>" + dateUnit + "^Ǝ햼</td>\n");
			tags.append("<td class='header_txt' nowrap>ANZX</td>\n");
			tags.append("<td class='header_txt'></td>\n");
			for (i = 0; i < num; i++) {
				 tags.append("<td class='header_data' nowrap>");
				 tags.append(CommonFunc.linkCategoryValue(
							category,
							"CategoryAccess",
							categoryCodes[i],
							categoryNames[i]
						)
					);
				 tags.append("</td>\n");
			}
			tags.append("</tr>\n");

			// htmle[u̍v쐬
			int total = 0;
			System.out.println(sql_ttl);
			rs = st.executeQuery(sql_ttl.toString());
			if (rs.next()) {
				// SANZX擾
				total = rs.getInt("ALLCOUNT");

				// sJn
				tags.append("<tr class='total'>");

				// "v"
				tags.append("<td class='total_txt'>v</td>\n");

				// vANZXƃp[Zg
				tags.append("<td class='total_num'>").append(numFormat.format(total)).append("</td>\n");
				tags.append("<td class='total_num'>").append(CommonFunc.getParcent(total, total)).append("</td>\n");

				// R[iƂ̍vANZX
				for(i = 0; i < num; i++)
					tags.append("<td class='total_num'>").append(numFormat.format(rs.getInt("COUNT" + i))).append("</td>\n");

				// sI
				tags.append("</tr>\n");
			}

			// Ƃ̏ꍇA擪"."t
			if (!category.equals("/")) {
				for (i = 0; i < num; i++)
					categoryCodes[i] = "." + categoryCodes[i];
			}

			// htmle[ũf[^쐬
			System.out.println(sql_row);
			rs = st.executeQuery(sql_row.toString());
			int subTotal = 0;
			int no = 1; // sԍ
			forwardPage = false;
			backPage = (offset != 0);
			boolean rankFlag = (selectcondBean.getPageNo2() == 0);
			while (rs.next()) {
				// y[W邩`FbN
				if (pageSize != 0 && no > pageSize) {
					forwardPage = true;
					break;
				}

				tags.append("<tr class='data'>");

				// 
				tags.append("<td class='data_date'>");
				tags.append(CommonFunc.getTimePeriod(table, rs.getDate("S_DATE"), rs.getString("MHD_HOLIDAY_CLS")));
				tags.append("</td>\n");

				// vANZXƃp[Zg
				int allCount = rs.getInt("ALLCOUNT");
				tags.append("<td class='data_access'>").append(numFormat.format(allCount)).append("</td>\n");
				tags.append("<td class='data_percent'>").append(CommonFunc.getParcent(total, allCount)).append("</td>\n");
				subTotal += allCount;

				// ԂƂ̃ANZX
				String date = CommonFunc.getDateRange(rs.getDate("S_DATE"), selectcondBean.getTable());
				for(i = 0; i < num; i++) {
					int count = rs.getInt("COUNT" + i);
					counterTbl[i] = count;
					categoryTotals[i] += count;
					dates[i] = date;
				}
				tags.append(CommonFunc.getCountValue(counterTbl, dates, categoryCodes, true, rankFlag));//ANZX̑P-3ʂɐF

				tags.append("</tr>\n");

				no++;
			}

			// htmle[ȕv쐬
			{
				// sJn
				tags.append("<tr class='subtotal'>");

				// "v"
				tags.append("<td class='subtotal_txt'>v</td>\n");

				// vANZXƃp[Zg
				tags.append("<td class='subtotal_num'>").append(numFormat.format(subTotal)).append("</td>\n");
				tags.append("<td class='subtotal_num'>").append(CommonFunc.getParcent(total, subTotal)).append("</td>\n");

				// R[iƂ̏vANZX
				for(i = 0; i < num; i++)
					tags.append("<td class='subtotal_num'>").append(numFormat.format(categoryTotals[i])).append("</td>\n");

				// sI
				tags.append("</tr>\n");
			}

			dbdata = tags.toString();
		} catch (SQLException e) {
			dbdata = "<font color='red'>WvɃG[܂B<br>" + e + "</font><br>";
			e.printStackTrace();
		}//try
	}
}