package xxx;
import base.*;
import java.sql.*;
import java.text.*;

/**
 * R[iOtĂяo鎞nOtv\쐬
 */
public class CornerGraphAccessBean  implements I_Access_Page {
  private String dbdata = "DB value";

  public String getDbdata() {
    return dbdata;
  }

  /**
   * R[i[nANZX̃e[u̒g쐬
   */
  public void searchDB(DataBase db, SelectCondBean selectcondBean) {
    try {
      Statement st = db.createStatement();
      ResultSet rs;
      NumberFormat numFormat = NumberFormat.getNumberInstance();
      int i;

      // R[i[R[h擾
      String corner = selectcondBean.getCorner();

      // e[uʂ̃wb_@ETEʕω
      String table = selectcondBean.getTable();
      String prefix = "", dateUnit = "";
      if (selectcondBean.getTable().equals("MONTH")) {
        prefix = "SMCC";
        dateUnit = "";
      } else if (selectcondBean.getTable().equals("WEEK")) {
        prefix = "SWCC";
        dateUnit = "T";
      } else if (selectcondBean.getTable().equals("DATE")) {
        prefix = "SDCC";
        dateUnit = "";
      }

      // \f[^擾SQL@cF
      StringBuffer sbuf;
      String select, where;

      // selectҏW
      sbuf = new StringBuffer();
      sbuf.append("[PF]_ACCESS[TB]_DATE as C_DATE \n");
      sbuf.append(",sum([PF]_ACCESSCOUNT_NUM) as ALLCOUNT \n");
      select = sbuf.toString();

      // whereҏW
      sbuf = new StringBuffer();
      sbuf.append("[PF]_ACCESS[TB]_DATE between '" + selectcondBean.getDateFrom() + "' and '" + selectcondBean.getDateTo() + "'\n");
      sbuf.append("and [PF]_CORNER_CODE='" + corner + "'\n");
//      sbuf.append("and [PF]_BUSINESSCATEGORY_CODE<>'UNDEFINED' \n");
      CommonSql.setAttributeSql(sbuf, selectcondBean);
      where = sbuf.toString();

      // sƂ̃ANZX擾邽߂̃TuNG
      StringBuffer s01 = new StringBuffer();
      s01.append("select " + select);
      s01.append("from S_[TB]_CORNER_COMPANY \n");
      s01.append("where " + where);
      s01.append("group by [PF]_ACCESS[TB]_DATE");

      // őANZX擾邽߂̃TuNG
      StringBuffer s02 = new StringBuffer();
      s02.append("select MAX(ALLCOUNT) as MAXCOUNT \n");
      s02.append("from (" + s01.toString() + ") \n");

      // TuNG܂Ƃ߂ĎsSQL쐬ixŎ擾j
      StringBuffer sql = new StringBuffer();
      sql.append("select s01.*,s02.*,MHD_HOLIDAY_CLS \n");
      sql.append("from (" + s01.toString() + ") s01 \n");
      sql.append(",(" + s02.toString() + ") s02 \n");
      sql.append(",M_HOLIDAY \n");
      sql.append("where C_DATE=MHD_HOLIDAY_DATE(+) \n");
      sql.append("order by C_DATE \n");

      // J̐ړƃe[uʖu
      CommonFunc.substitute(sql, "[PF]", prefix);
      CommonFunc.substitute(sql, "[TB]", table);

      // SQLs
      System.out.println(sql);
      rs = st.executeQuery(sql.toString());

      // htmle[ũwb_쐬
      StringBuffer tags= new StringBuffer();
      tags.append("<tr class='header'>");
      tags.append("<td class='header_txt' width='100'>" + dateUnit + "</td>\n");
      tags.append("<td class='header_txt'>ANZX</td>\n");
      tags.append("<td class='header_txt'>Ot</td>\n");
      tags.append("</tr>\n");

      // htmle[ũf[^쐬
      while(rs.next()){
        tags.append("<tr class='data'>");

        // 
        tags.append("<td class='data_date'>");
        tags.append(CommonFunc.getTimePeriod(table, rs.getDate("C_DATE"), rs.getString("MHD_HOLIDAY_CLS")));
        tags.append("</td>\n");

        // vANZX
        int allCount = rs.getInt("ALLCOUNT");
        tags.append("<td class='data_access'>").append(numFormat.format(allCount)).append("</td>\n");

        // _Ot
        tags.append("<td class='data_graph'>");
        tags.append(CommonFunc.genGraphImage(allCount, rs.getInt("MAXCOUNT")));//GIF̕vZ
        tags.append("</td>\n");

        tags.append("</tr>\n");
      }

      dbdata = tags.toString();
    } catch (SQLException e) {
      dbdata = "<font color='red'>WvɃG[܂B<br>" + e + "</font><br>";
			e.printStackTrace();
		}//try
  }

}