package xxx;
import java.sql.*;
import base.*;
import java.text.*;

/**
* ƎʃR[i[ʃANZXz\쐬
*/
public class CrossCategoryAccessBean implements I_Access_Page {
	private String dbdata = "DB value";
	private boolean forwardPage;
	private boolean backPage;

	public String getDbdata() {
		return dbdata;
	}

	public String getDisableForwardPage() {
		return forwardPage ? "" : " disabled";
	}

	public String getDisableBackPage() {
		return backPage ? "" : " disabled";
	}

	/**
	* ƎʃR[i[ʃANZXz\̒g쐬
	*/
	public void searchDB(DataBase db, SelectCondBean selectcondBean) {
		try {
			Statement st = db.createStatement();
			ResultSet rs;
			NumberFormat numFormat = NumberFormat.getNumberInstance();
			int i;

			// R[i[AKwAJeS擾
			String corner = selectcondBean.getCorner();
			int cornerDepth = Integer.parseInt(selectcondBean.getCornerdepth());
			String category = selectcondBean.getCategory();

			// 及L̃R[i[`FbN
			String groupCorner = selectcondBean.getGroupCorner(db);
			if (groupCorner.length() > corner.length() || !groupCorner.equals(corner.substring(0, groupCorner.length()))) {
				corner = groupCorner;
				selectcondBean.setCorner(corner);
				cornerDepth = CommonSql.getCornerDepth(st, corner) + 1;
				selectcondBean.setCornerdepth(String.valueOf(cornerDepth));
			}

			// iR[i[j̏i[邽߂̔zm
			int num = CommonSql.getCornerCount(st, corner, cornerDepth) + 1;
			String cornerCodes[] = new String[num];       // R[iR[h
			String cornerNames[] = new String[num];       // R[i
			boolean cornerLinks[] = new boolean[num];     // R[ĩNtO
			int cornerTotals[] = new int[num];            // R[i[̃ANZXv
			String categoryCodes[] = new String[num];     // JeSR[h
			int[] counterTbl = new int[num];              // ANZXJE^

			// R[i[̏iR[i[R[hAR[i[AN̗LjzɎ擾
			rs = CommonSql.getCornerResult(st, corner, cornerDepth);
			for (i = 0; i < num && rs.next(); i++) {
				cornerCodes[i] = rs.getString("cornercode").trim();
				cornerNames[i] = CommonFunc.getLaxxxornerName(rs.getString("cornername"));
				if (selectcondBean.getCornerdepth().equals("6"))
					cornerLinks[i] = false;   // R[i̐[ȔꍇN؂@0
				else
					cornerLinks[i] = rs.getBoolean("link");
			}

			// uṽNǉ@iR[ĩy[Wւ̃ANZX́@ꊇ@R[iR[h/$@ŋL^j
			// ܂R[iꗗɁuvƂR[iR[hǉĂB
			cornerCodes[i] = corner + "$/";
			cornerNames[i] = "";
			cornerLinks[i] = false;

			// R[iPKwڂɂ́uݒOvƂR[i݂iǂ̃R[iɂYȂANZXjB
			// vOł́uv΂Eɂ邪
			// fUĆuݒOvԉEȂ̂ŒlւĂB
			if (cornerDepth == 1 && i > 1 && cornerCodes[i - 1].equals("/NOCODE/")) {
				CommonFunc.swap(cornerCodes, i, i - 1);
				CommonFunc.swap(cornerNames, i, i - 1);
				CommonFunc.swap(cornerLinks, i, i - 1);
			}

			// e[uʂ̃wb_@ETEʕω
			String table = selectcondBean.getTable();
			String prefix = "";
			if (selectcondBean.getTable().equals("MONTH")) {
				prefix = "SMCC";
			} else if (selectcondBean.getTable().equals("WEEK")) {
				prefix = "SWCC";
			} else if (selectcondBean.getTable().equals("DATE")) {
				prefix = "SDCC";
			}

			// ƎiƁjR[h̃J擾
			String s_code;
			if (category.equals("/"))
				s_code = "[PF]_BUSINESSCATEGORY_CODE";
			else
				s_code = "[PF]_COMPANY_CODE";

			// JeSAR[i[ʂ̃ANZXWvpTuNG
			StringBuffer q01 = new StringBuffer();
			q01.append("select ");
			q01.append("[PF]_CORNER_CODE as S_CORNER_CODE,");
			q01.append(s_code + " as S_CATEGORY_CODE,");
			q01.append("sum([PF]_ACCESSCOUNT_NUM) as S_ACCESSCOUNT_NUM \n");
			q01.append("from S_[TB]_CORNER_COMPANY \n");
			q01.append("where ");
			q01.append("[PF]_ACCESS[TB]_DATE between '" + selectcondBean.getDateFrom() + "' and '" + selectcondBean.getDateTo() + "'\n");
			q01.append("and [PF]_CORNERPARENT_CODE='" + corner + "'\n");
			q01.append("and [PF]_CORNER_CODE<>'/'\n");
			if (!category.equals("/"))
				q01.append("and [PF]_BUSINESSCATEGORY_CODE='" + category + "' \n");
			CommonSql.setAttributeSql(q01, selectcondBean);
			q01.append("group by [PF]_CORNER_CODE," + s_code + " \n");

			// J̐ړƃe[uʖu
			CommonFunc.substitute(q01, "[PF]", prefix);
			CommonFunc.substitute(q01, "[TB]", table);

			// ʂɏWv邽߂select
			StringBuffer select = new StringBuffer();
			select.append("sum(S_ACCESSCOUNT_NUM) as ALLCOUNT \n");
			for (i = 0; i < num; i++)
				select.append(",sum(CASE S_CORNER_CODE when '" + cornerCodes[i] + "' then S_ACCESSCOUNT_NUM else 0 end) as COUNT" + i + "\n");

			// v擾邽߂SQL
			StringBuffer sql_ttl = new StringBuffer();
			sql_ttl.append("select " + select);
			sql_ttl.append("from (" + q01 + ") \n");

			// sƂ̃ANZX擾邽߂̃TuNG
			StringBuffer q02 = new StringBuffer();
			q02.append("select " + select + ",S_CATEGORY_CODE \n");
			q02.append("from (" + q01 + ") \n");
			q02.append("group by S_CATEGORY_CODE");

			// ƎiƁj擾邽߂̏
			String c_table, c_code, c_text, c_sort, c_where;
			if (category.equals("/")) {
				c_table = "M_BUSINESSCATEGORY";
				c_code = "MBC_BUSINESSCATEGORY_CODE";
				c_text = "MBC_DISPNAME_TXT";
				c_sort = "MBC_SORT_NUM";
				c_where = "";
			} else {
				c_table = "M_COMPANY";
				c_code = "MCM_COMPANY_CODE";
				c_text = "MCM_DISPNAME_TXT";
				c_sort = "MCM_SORT_NUM";
				c_where = "and MCM_BUSINESSCATEGORY_CODE='" + category + "' \n" + CommonSql.setAttributeSql2(selectcondBean);
			}

			// ANZX̏ꍇȋ͈ԉɂj
			if (selectcondBean.getOrder().equals("ALLCOUNT"))
				c_sort = "DECODE(" + c_code + ",'UNDEFINED', -1, NVL(ALLCOUNT,0)) DESC";

			// ƎiƁj擾邽߂̃TuNG
			StringBuffer q03 = new StringBuffer();
			q03.append("select " + c_code + " as C_CODE," + c_text + " as C_TEXT,q02.* \n");
			q03.append("from " + c_table + ",(" + q02 + ") q02 \n");
			q03.append("where S_CATEGORY_CODE(+)=" + c_code + "\n");
			q03.append(c_where);
			q03.append("order by " + c_sort + "\n");

			// KvȔ͈͂̃f[^݂̂𒊏o
			int pageSize;
			int offset;
			StringBuffer sql_row = new StringBuffer();
			if (category.equals("/")) {
				pageSize = 0;
				offset = 0;
				sql_row.append(q03);
			} else {
				pageSize = selectcondBean.getPageSize();
				offset = selectcondBean.getPageNo() * pageSize;
				sql_row.append(CommonSql.RowRange(q03.toString(), offset, pageSize + 1)); // y[W邩`FbN邽߂Pǂ
			}

			// htmle[ũwb_쐬
			StringBuffer tags = new StringBuffer();
			tags.append("<tr class='header'>");
			tags.append("<td class='header_no'>No.</td>\n");
			tags.append("<td class='header_txt' nowrap>  </td>\n");
			tags.append("<td class='header_txt' nowrap>ANZX</td>\n");
			tags.append("<td class='header_txt'></td>\n");
			for(i = 0; i < num; i++){
				tags.append("<td class='header_data' nowrap>");
				tags.append(CommonFunc.linkCornerValue(
						cornerLinks[i],
						"CrossCategoryAccess",
						cornerCodes[i],
						cornerNames[i],
						cornerDepth + 1
					)
				);
				tags.append("</td>\n");
			}
			tags.append("</tr>\n");

			// htmle[u̍v쐬
			int total = 0;
			System.out.println(sql_ttl);
			rs = st.executeQuery(sql_ttl.toString());
			if (rs.next()) {
				// SANZX擾
				total = rs.getInt("ALLCOUNT");

				// sJn
				tags.append("<tr class='total'>");

				// ԍi󔒁j
				tags.append("<td>@</td>\n");

				// "v"
				tags.append("<td class='total_txt'>v</td>\n");

				// vANZXƃp[Zg
				tags.append("<td class='total_num'>").append(numFormat.format(total)).append("</td>\n");
				tags.append("<td class='total_num'>").append(CommonFunc.getParcent(total, total)).append("</td>\n");

				// R[iƂ̍vANZX
				for(i = 0; i < num; i++)
					tags.append("<td class='total_num'>").append(numFormat.format(rs.getInt("COUNT" + i))).append("</td>\n");

				// sI
				tags.append("</tr>\n");
			}

			// htmle[ũf[^쐬
			System.out.println(sql_row);
			rs = st.executeQuery(sql_row.toString());
			int subTotal = 0; // v
			int no = 1; // sԍ
			forwardPage = false;
			backPage = (offset != 0);
			while(rs.next()){
				// y[W邩`FbN
				if (pageSize != 0 && no > pageSize) {
					forwardPage = true;
					break;
				}

				// sJn
				tags.append("<tr class='data'>");

				// ԍ
				tags.append("<td class='data_no'>").append(no + offset).append("</td>\n");

				// ƎiƁj
				String categoryCode = rs.getString("C_CODE").trim();
				tags.append("<td class='data_category'>");
				tags.append(CommonFunc.linkCategoryValue(
						category,
						"CrossCategoryAccess",
						categoryCode,
						rs.getString("C_TEXT").trim()
					)
				);
				tags.append("</td>\n");

				// vANZXƃp[Zg
				int allCount = rs.getInt("ALLCOUNT");
				tags.append("<td class='data_access'>").append(numFormat.format(allCount)).append("</td>\n");
				tags.append("<td class='data_percent'>").append(CommonFunc.getParcent(total, allCount)).append("</td>\n");
				subTotal += allCount;

				// R[iƂ̃ANZX
				for(i = 0; i < num; i++) {
					int count = rs.getInt("COUNT" + i);
					counterTbl[i] = count;
					cornerTotals[i] += count;
					if (!category.equals("/"))   // ƎR[hƊƃR[hʂ邽ߊƃR[h̐擪"."t
						categoryCodes[i] = "." + categoryCode;
					else
						categoryCodes[i] = categoryCode;
				}
				tags.append(CommonFunc.getCountValue(counterTbl, categoryCodes, cornerCodes, true, true));  //ANZX̑P-3ʂɐF

				// sI
				tags.append("</tr>\n");

				no++;
			}

			// htmle[ȕv쐬
			{
				// sJn
				tags.append("<tr class='subtotal'>");

				// ԍi󔒁j
				tags.append("<td>@</td>\n");

				// "v"
				tags.append("<td class='subtotal_txt'>v</td>\n");

				// vANZXƃp[Zg
				tags.append("<td class='subtotal_num'>").append(numFormat.format(subTotal)).append("</td>\n");
				tags.append("<td class='subtotal_num'>").append(CommonFunc.getParcent(total, subTotal)).append("</td>\n");

				// R[iƂ̏vANZX
				for(i = 0; i < num; i++)
					tags.append("<td class='subtotal_num'>").append(numFormat.format(cornerTotals[i])).append("</td>\n");

				// sI
				tags.append("</tr>\n");
			}

			// htmlۑ
			dbdata = tags.toString();
		} catch (SQLException e) {
			dbdata = "<font color='red'>WvɃG[܂B<br>" + e + "</font><br>";
			e.printStackTrace();
		}//try
	}
}//class