package xxx;
import base.*;
import java.sql.*;
import java.text.*;


/**
 * R[i[ʃANZXڕ\쐬
 */
public class CornerAccessBean implements I_Access_Page {
	private String dbdata = "DB value";
	private boolean forwardPage;
	private boolean backPage;

	public String getDbdata() {
		return dbdata;
	}

	public String getDisableForwardPage() {
		return forwardPage ? "" : " disabled";
	}

	public String getDisableBackPage() {
		return backPage ? "" : " disabled";
	}

	/**
	 * R[i[ʃANZXڕ\̒g쐬
	 */
	public void searchDB(DataBase db, SelectCondBean selectcondBean) {
		try{
			Statement st = db.createStatement();
			ResultSet rs;
			NumberFormat numFormat = NumberFormat.getNumberInstance();
			int i;

			// R[i[AKwAJeS擾
			String corner = selectcondBean.getCorner();
			int cornerDepth = Integer.parseInt(selectcondBean.getCornerdepth());
			String category = selectcondBean.getCategory();

			// iR[i[j̏i[邽߂̔zm
			int num = CommonSql.getCornerCount(st, corner, cornerDepth) + 1;
			String cornerCodes[] = new String[num];     // R[i[R[h
			String cornerNames[] = new String[num];     // R[i[
			boolean cornerLinks[] = new boolean[num];   // R[i[̃NtO
			int cornerTotals[] = new int[num];          // R[i[̃ANZXv
			int counterTbl[] = new int[num];            // ANZXJE^
			String dates[] = new String[num];           // 

			// R[i[̏iR[i[R[hAR[i[AN̗LjzɎ擾
			rs = CommonSql.getCornerResult(st, corner, cornerDepth);
			for (i = 0; i < num && rs.next(); i++) {
				cornerCodes[i] = rs.getString("cornercode").trim();
				cornerNames[i] = CommonFunc.getLaxxxornerName(rs.getString("cornername"));
				if (selectcondBean.getCornerdepth().equals("6"))
					cornerLinks[i] = false;   // R[i̐[ȔꍇN؂@0
				else
					cornerLinks[i] = rs.getBoolean("link");
			}

			// uṽNǉ@iR[ĩy[Wւ̃ANZX́@ꊇ@R[iR[h/$@ŋL^j
			// ܂R[iꗗɁuvƂR[iR[hǉĂB
			cornerCodes[i] = corner + "$/";
			cornerNames[i] = "";
			cornerLinks[i] = false;

			// R[iPKwڂɂ́uݒOvƂR[i݂iǂ̃R[iɂYȂANZXjB
			// vOł́uv΂Eɂ邪
			// fUĆuݒOvԉEȂ̂ŒlւĂB
			if (cornerDepth == 1 && i > 1 && cornerCodes[i - 1].equals("/NOCODE/")) {
				CommonFunc.swap(cornerCodes, i, i - 1);
				CommonFunc.swap(cornerNames, i, i - 1);
				CommonFunc.swap(cornerLinks, i, i - 1);
			}

			// e[uʂ̃wb_@ETEʕω
			String table = selectcondBean.getTable();
			String prefix = "", dateUnit = "";
			if (table.equals("MONTH")) {
				prefix = "SMCC";
				dateUnit = "";
			} else if (table.equals("WEEK")) {
				prefix = "SWCC";
				dateUnit = "T";
			} else if (table.equals("DATE")) {
				prefix = "SDCC";
				dateUnit = "t";
			}

			// tAJeSʂ̃ANZXWvpTuNG
			StringBuffer q01 = new StringBuffer();
			q01.append("select ");
			q01.append("[PF]_ACCESS[TB]_DATE as S_DATE,");
			q01.append("[PF]_CORNER_CODE as S_CORNER_CODE,");
			q01.append("sum([PF]_ACCESSCOUNT_NUM) as S_ACCESSCOUNT_NUM \n");
			q01.append("from S_[TB]_CORNER_COMPANY \n");
			q01.append("where ");
			q01.append("[PF]_ACCESS[TB]_DATE between '" + selectcondBean.getDateFrom() + "' and '" + selectcondBean.getDateTo() + "'\n");
			q01.append("and [PF]_CORNERPARENT_CODE='" + corner + "'\n");
			q01.append("and [PF]_CORNER_CODE<>'/' \n");
			if (!category.equals("/"))
				q01.append("and [PF]_BUSINESSCATEGORY_CODE='" + category + "' \n");
			CommonSql.setAttributeSql(q01, selectcondBean);
			q01.append("group by [PF]_ACCESS[TB]_DATE,[PF]_CORNER_CODE \n");

			// J̐ړƃe[uʖu
			CommonFunc.substitute(q01, "[PF]", prefix);
			CommonFunc.substitute(q01, "[TB]", table);

			// ʂɏWv邽߂select
			StringBuffer select = new StringBuffer();
			select.append("sum(S_ACCESSCOUNT_NUM) as ALLCOUNT \n");
			for (i = 0; i < num; i++)
				select.append(",sum(CASE S_CORNER_CODE when '" + cornerCodes[i] + "' then S_ACCESSCOUNT_NUM else 0 end) as COUNT" + i + "\n");

			// v擾邽߂SQL
			StringBuffer sql_ttl = new StringBuffer();
			sql_ttl.append("select " + select);
			sql_ttl.append("from (" + q01 + ") \n");

			// sƂ̃ANZX擾邽߂̃TuNG
			StringBuffer q02 = new StringBuffer();
			q02.append("select " + select + ",S_DATE \n");
			q02.append("from (" + q01 + ") \n");
			q02.append("group by S_DATE");

			// x}X^ƌ
			StringBuffer q03 = new StringBuffer();
			q03.append("select q02.*,MHD_HOLIDAY_CLS \n");
			q03.append("from (" + q02 + ") q02 \n");
			q03.append(",M_HOLIDAY \n");
			q03.append("where S_DATE=MHD_HOLIDAY_DATE(+) \n");
			q03.append("order by S_DATE \n");

			// KvȔ͈͂̃f[^݂̂𒊏o
			StringBuffer sql_row = new StringBuffer();
			int pageSize = selectcondBean.getPageSize();
			int offset = selectcondBean.getPageNo() * pageSize;
			sql_row.append(CommonSql.RowRange(q03.toString(), offset, pageSize + 1)); // y[W邩`FbN邽߂Pǂ

			// htmle[ũwb_쐬
			StringBuffer tags = new StringBuffer();
			tags.append("<tr class='header'>\n");
			tags.append("<td class='header_no' nowrap>" + dateUnit + "^R[i[</td>\n");
			tags.append("<td class='header_txt' nowrap>ANZX</td>\n");
			tags.append("<td class='header_txt'></td>\n");
			for (i = 0; i < num; i++) {
				tags.append("<td class='header_data' nowrap>");
				tags.append(CommonFunc.linkCornerValue(
					cornerLinks[i],
					"CrossCategoryAccess",
					cornerCodes[i],
					cornerNames[i],
					cornerDepth + 1
					)
				);
				tags.append("</td>\n");
			}
			tags.append("</tr>\n");

			// htmle[u̍v쐬
			int total = 0;
			System.out.println(sql_ttl);
			rs = st.executeQuery(sql_ttl.toString());
			if (rs.next()) {
				// SANZX擾
				total = rs.getInt("ALLCOUNT");

				// sJn
				tags.append("<tr class='total'>");

				// "v"
				tags.append("<td class='total_txt'>v</td>\n");

				// vANZXƃp[Zg
				tags.append("<td class='total_num'>").append(numFormat.format(total)).append("</td>\n");
				tags.append("<td class='total_num'>").append(CommonFunc.getParcent(total, total)).append("</td>\n");

				// R[iƂ̍vANZX
				for(i = 0; i < num; i++)
					tags.append("<td class='total_num'>").append(numFormat.format(rs.getInt("COUNT" + i))).append("</td>\n");

				// sI
				tags.append("</tr>\n");
			}

			// htmle[ũf[^쐬
			System.out.println(sql_row);
			rs = st.executeQuery(sql_row.toString());
			int subTotal = 0;
			int no = 1; // sԍ
			forwardPage = false;
			backPage = (offset != 0);
			while (rs.next()) {
				// y[W邩`FbN
				if (pageSize != 0 && no > pageSize) {
					forwardPage = true;
					break;
				}

				tags.append("<tr class='data'>");

				// 
				tags.append("<td class='data_date'>");
				tags.append(CommonFunc.getTimePeriod(table, rs.getDate("S_DATE"), rs.getString("MHD_HOLIDAY_CLS")));
				tags.append("</td>\n");

				// vANZXƃp[Zg
				int allCount = rs.getInt("ALLCOUNT");
				tags.append("<td class='data_access'>").append(numFormat.format(allCount)).append("</td>\n");
				tags.append("<td class='data_percent'>").append(CommonFunc.getParcent(total, allCount)).append("</td>\n");
				subTotal += allCount;

				// ԂƂ̃ANZX
				String date = CommonFunc.getDateRange(rs.getDate("S_DATE"), selectcondBean.getTable());
				for(i = 0; i < num; i++) {
					int count = rs.getInt("COUNT" + i);
					counterTbl[i] = count;
					cornerTotals[i] += count;
					dates[i] = date;
				}
				tags.append(CommonFunc.getCountValue(counterTbl, dates, cornerCodes, true, true));//ANZX̑P-3ʂɐF

				tags.append("</tr>\n");

				no++;
			}

			// htmle[ȕv쐬
			{
				// sJn
				tags.append("<tr class='subtotal'>");

				// "v"
				tags.append("<td class='subtotal_txt'>v</td>\n");

				// vANZXƃp[Zg
				tags.append("<td class='subtotal_num'>").append(numFormat.format(subTotal)).append("</td>\n");
				tags.append("<td class='subtotal_num'>").append(CommonFunc.getParcent(total, subTotal)).append("</td>\n");

				// R[iƂ̏vANZX
				for(i = 0; i < num; i++)
					tags.append("<td class='subtotal_num'>").append(numFormat.format(cornerTotals[i])).append("</td>\n");

				// sI
				tags.append("</tr>\n");
			}

			dbdata = tags.toString();
		} catch (SQLException e) {
			dbdata = "<font color='red'>WvɃG[܂B<br>" + e + "</font><br>";
			e.printStackTrace();
		}//try
	}
}